# Uses of Class
org.apache.sysds.runtime.matrix.data.Pair

Packages that use Pair
Package
Description
org.apache.sysds.hops.codegen.template
org.apache.sysds.runtime.compress.colgroup.indexes
org.apache.sysds.runtime.compress.colgroup.scheme
org.apache.sysds.runtime.controlprogram.context
org.apache.sysds.runtime.frame.data
org.apache.sysds.runtime.frame.data.columns
org.apache.sysds.runtime.functionobjects
org.apache.sysds.runtime.instructions.spark.data
org.apache.sysds.runtime.instructions.spark.utils
org.apache.sysds.runtime.iogen
org.apache.sysds.runtime.iogen.template
org.apache.sysds.runtime.matrix.data
org.apache.sysds.runtime.transform.decode
org.apache.sysds.runtime.transform.meta
org.apache.sysds.runtime.util

## Uses of Pair in org.apache.sysds.hops.codegen.template

Methods in org.apache.sysds.hops.codegen.template that return Pair
Modifier and Type
Method
Description
`abstract Pair<Hop[],CNodeTpl>`
TemplateBase.`constructCplan(Hop hop, CPlanMemoTable memo, boolean compileLiterals)`
Constructs a single cplan rooted at the given hop, according to the plan given in the memo structure for this particular hop and its recursive inputs.
`Pair<Hop[],CNodeTpl>`
TemplateCell.`constructCplan(Hop hop, CPlanMemoTable memo, boolean compileLiterals)`
`Pair<Hop[],CNodeTpl>`
TemplateMultiAgg.`constructCplan(Hop hop, CPlanMemoTable memo, boolean compileLiterals)`
`Pair<Hop[],CNodeTpl>`
TemplateOuterProduct.`constructCplan(Hop hop, CPlanMemoTable memo, boolean compileLiterals)`
`Pair<Hop[],CNodeTpl>`
TemplateRow.`constructCplan(Hop hop, CPlanMemoTable memo, boolean compileLiterals)`

## Uses of Pair in org.apache.sysds.runtime.compress.colgroup.indexes

Methods in org.apache.sysds.runtime.compress.colgroup.indexes that return Pair
Modifier and Type
Method
Description
`static Pair<int[],int[]>`
IColIndex.`reorderingIndexes(IColIndex a, IColIndex b)`

## Uses of Pair in org.apache.sysds.runtime.compress.colgroup.scheme

Methods in org.apache.sysds.runtime.compress.colgroup.scheme that return Pair
Modifier and Type
Method
Description
`final Pair<ICLAScheme,AColGroup>`
ACLAScheme.`updateAndEncode(MatrixBlock data)`
`final Pair<ICLAScheme,AColGroup>`
ACLAScheme.`updateAndEncode(MatrixBlock data, IColIndex columns)`
`Pair<ICLAScheme,AColGroup>`
ICLAScheme.`updateAndEncode(MatrixBlock data)`
Update and encode the given block in a single pass.
`Pair<ICLAScheme,AColGroup>`
ICLAScheme.`updateAndEncode(MatrixBlock data, IColIndex columns)`
Try to update and encode in a single pass over the data.
`final Pair<ICLAScheme,AColGroup>`
ACLAScheme.`updateAndEncodeT(MatrixBlock data)`
`final Pair<ICLAScheme,AColGroup>`
ACLAScheme.`updateAndEncodeT(MatrixBlock data, IColIndex columns)`
`Pair<ICLAScheme,AColGroup>`
ICLAScheme.`updateAndEncodeT(MatrixBlock data)`
Update and encode the given block in a single pass.
`Pair<ICLAScheme,AColGroup>`
ICLAScheme.`updateAndEncodeT(MatrixBlock data, IColIndex columns)`
Try to update and encode in a single pass over the data.

## Uses of Pair in org.apache.sysds.runtime.controlprogram.context

Methods in org.apache.sysds.runtime.controlprogram.context that return Pair
Modifier and Type
Method
Description
`Pair<MatrixObject,Boolean>`
ExecutionContext.`getDenseMatrixOutputForGPUInstruction(String varName, long numRows, long numCols)`
Allocates a dense matrix on the GPU (for output)
`Pair<MatrixObject,Boolean>`
ExecutionContext.`getDenseMatrixOutputForGPUInstruction(String varName, long numRows, long numCols, boolean initialize)`
`Pair<MatrixObject,Boolean>`
ExecutionContext.`getSparseMatrixOutputForGPUInstruction(String varName, long numRows, long numCols, long nnz)`
Allocates a sparse matrix in CSR format on the GPU.
`Pair<MatrixObject,Boolean>`
ExecutionContext.`getSparseMatrixOutputForGPUInstruction(String varName, long numRows, long numCols, long nnz, boolean initialize)`

## Uses of Pair in org.apache.sysds.runtime.frame.data

Method parameters in org.apache.sysds.runtime.frame.data with type arguments of type Pair
Modifier and Type
Method
Description
`void`
FrameBlock.`slice(ArrayList<Pair<Long,FrameBlock>> outList, IndexRange range, int rowCut)`

## Uses of Pair in org.apache.sysds.runtime.frame.data.columns

Methods in org.apache.sysds.runtime.frame.data.columns that return Pair
Modifier and Type
Method
Description
`final Pair<Types.ValueType,Boolean>`
Array.`analyzeValueType()`
Analyze the column to figure out if the value type can be refined to a better type.
`abstract Pair<Types.ValueType,Boolean>`
Array.`analyzeValueType(int maxCells)`
Analyze the column to figure out if the value type can be refined to a better type.
`Pair<Types.ValueType,Boolean>`
BitSetArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
BooleanArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
CharArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
DDCArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
DoubleArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
FloatArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
HashIntegerArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
HashLongArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
IntegerArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
LongArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
OptionalArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
RaggedArray.`analyzeValueType(int maxCells)`
`Pair<Types.ValueType,Boolean>`
StringArray.`analyzeValueType(int maxCells)`
`Pair<Integer,Integer>`
Array.`getMinMaxLength()`
Get the minimum and maximum length of the contained values as string type.
`Pair<Integer,Integer>`
StringArray.`getMinMaxLength()`

## Uses of Pair in org.apache.sysds.runtime.functionobjects

Methods in org.apache.sysds.runtime.functionobjects that return Pair
Modifier and Type
Method
Description
`Pair<MatrixIndexes,Double>`
CTable.`execute(long row, double v2, double w)`

## Uses of Pair in org.apache.sysds.runtime.instructions.spark.data

Method parameters in org.apache.sysds.runtime.instructions.spark.data with type arguments of type Pair
Modifier and Type
Method
Description
`void`
FrameReblockBuffer.`flushBufferToBinaryBlocks(ArrayList<Pair<Long,FrameBlock>> outList)`

## Uses of Pair in org.apache.sysds.runtime.instructions.spark.utils

Methods in org.apache.sysds.runtime.instructions.spark.utils that return Pair
Modifier and Type
Method
Description
`static Pair<MatrixIndexes,MatrixBlock>`
SparkUtils.`fromIndexedMatrixBlockToPair(IndexedMatrixValue in)`
`static Pair<Long,FrameBlock>`
SparkUtils.`toIndexedFrameBlock(scala.Tuple2<Long,FrameBlock> in)`
Methods in org.apache.sysds.runtime.instructions.spark.utils that return types with arguments of type Pair
Modifier and Type
Method
Description
`static List<Pair<MatrixIndexes,MatrixBlock>>`
SparkUtils.`fromIndexedMatrixBlockToPair(List<IndexedMatrixValue> in)`
`static List<Pair<Long,Long>>`
SparkUtils.`toIndexedLong(List<scala.Tuple2<Long,Long>> in)`
Methods in org.apache.sysds.runtime.instructions.spark.utils with parameters of type Pair
Modifier and Type
Method
Description
`static org.apache.spark.api.java.JavaPairRDD<Long,FrameBlock>`
FrameRDDConverterUtils.`dataFrameToBinaryBlock(org.apache.spark.api.java.JavaSparkContext sc, org.apache.spark.sql.Dataset<org.apache.spark.sql.Row> df, DataCharacteristics mc, boolean containsID, Pair<String[],Types.ValueType[]> out)`
`static scala.Tuple2<Long,FrameBlock>`
SparkUtils.`fromIndexedFrameBlock(Pair<Long,FrameBlock> in)`
Method parameters in org.apache.sysds.runtime.instructions.spark.utils with type arguments of type Pair
Modifier and Type
Method
Description
`static List<scala.Tuple2<Long,FrameBlock>>`
SparkUtils.`fromIndexedFrameBlock(List<Pair<Long,FrameBlock>> in)`

## Uses of Pair in org.apache.sysds.runtime.iogen

Methods in org.apache.sysds.runtime.iogen that return Pair
Modifier and Type
Method
Description
`Pair<ArrayList<String>,ArrayList<Integer>>`
FormatIdentifyer.`extractAllPrefixStringsOfAColSingleLine(int colIndex, boolean reverse, boolean removesSelected)`
`Pair<ArrayList<String>,ArrayList<Integer>>`
FormatIdentifyer.`extractAllPrefixStringsOfAColSingleLine(int r, ArrayList<Integer> colIndexes, boolean reverse, boolean removesSelected)`
`Pair<ArrayList<String>[],ArrayList<Integer>[]>`
FormatIdentifyer.`extractAllPrefixStringsOfColsSingleLine(boolean reverse, boolean removesSelected)`
`Pair<Integer,Integer>`
RawIndex.`findValue(double value)`
`Pair<Integer,Integer>`
RawIndex.`findValue(Object value, Types.ValueType valueType)`
Methods in org.apache.sysds.runtime.iogen that return types with arguments of type Pair
Modifier and Type
Method
Description
`ArrayList<Pair<String,Set<Integer>>>`
TextTrie.`getAllKeys()`

## Uses of Pair in org.apache.sysds.runtime.iogen.template

Methods in org.apache.sysds.runtime.iogen.template that return Pair
Modifier and Type
Method
Description
`static Pair<ArrayList<Pair<Long,Integer>>,Long>`
TemplateUtil.`getTokenIndexOnMultiLineRecords(org.apache.hadoop.mapred.InputSplit split, org.apache.hadoop.mapred.TextInputFormat inputFormat, org.apache.hadoop.mapred.JobConf job, String token)`
Methods in org.apache.sysds.runtime.iogen.template that return types with arguments of type Pair
Modifier and Type
Method
Description
`static Pair<ArrayList<Pair<Long,Integer>>,Long>`
TemplateUtil.`getTokenIndexOnMultiLineRecords(org.apache.hadoop.mapred.InputSplit split, org.apache.hadoop.mapred.TextInputFormat inputFormat, org.apache.hadoop.mapred.JobConf job, String token)`

## Uses of Pair in org.apache.sysds.runtime.matrix.data

Methods in org.apache.sysds.runtime.matrix.data that return Pair
Modifier and Type
Method
Description
`Pair<org.apache.hadoop.io.NullWritable,org.apache.hadoop.io.Text>`
BinaryBlockToTextCellConverter.`next()`
`Pair<K2,V2>`
Converter.`next()`
Methods in org.apache.sysds.runtime.matrix.data that return types with arguments of type Pair
Modifier and Type
Method
Description
`static ArrayList<Pair<Long,FrameBlock>>`
OperationsOnMatrixValues.`performSlice(Pair<Long,FrameBlock> in, IndexRange ixrange, int blen)`
This function will get slice of the input frame block overlapping in overall slice(Range), slice has requested for.
Methods in org.apache.sysds.runtime.matrix.data with parameters of type Pair
Modifier and Type
Method
Description
`static void`
OperationsOnMatrixValues.`performShift(Pair<Long,FrameBlock> in, IndexRange ixrange, int blenLeft, long rlen, long clen, ArrayList<Pair<Long,FrameBlock>> outlist)`
`static ArrayList<Pair<Long,FrameBlock>>`
OperationsOnMatrixValues.`performSlice(Pair<Long,FrameBlock> in, IndexRange ixrange, int blen)`
This function will get slice of the input frame block overlapping in overall slice(Range), slice has requested for.
Method parameters in org.apache.sysds.runtime.matrix.data with type arguments of type Pair
Modifier and Type
Method
Description
`static void`
OperationsOnMatrixValues.`performShift(Pair<Long,FrameBlock> in, IndexRange ixrange, int blenLeft, long rlen, long clen, ArrayList<Pair<Long,FrameBlock>> outlist)`

## Uses of Pair in org.apache.sysds.runtime.transform.decode

Methods in org.apache.sysds.runtime.transform.decode with parameters of type Pair
Modifier and Type
Method
Description
`static void`
DecoderRecode.`parseRecodeMapEntry(String entry, Pair<String,String> pair)`
Parses a line of <token, ID, count> into <token, ID> pairs, where quoted tokens (potentially including separators) are supported.

## Uses of Pair in org.apache.sysds.runtime.transform.meta

Constructor parameters in org.apache.sysds.runtime.transform.meta with type arguments of type Pair
Modifier
Constructor
Description
``
`TfOffsetMap(List<Pair<Long,Long>> rmRows)`

## Uses of Pair in org.apache.sysds.runtime.util

Methods in org.apache.sysds.runtime.util that return types with arguments of type Pair
Modifier and Type
Method
Description
`static List<Pair<Integer,Integer>>`
UtilFunctions.`getTaskRangesDefault(int len, int k)`
Methods in org.apache.sysds.runtime.util with parameters of type Pair
Modifier and Type
Method
Description
`static IndexRange`
UtilFunctions.`getSelectedRangeForZeroOut(Pair<Long,FrameBlock> in, int blen, IndexRange indexRange, long lSrcRowIndex, long lDestRowIndex)`
`static int`
LocalFileUtils.`readBlockSequenceFromLocal(String fname, Pair<MatrixIndexes,MatrixValue>[] outValues, HashMap<MatrixIndexes,Integer> outMap)`
`static void`
LocalFileUtils.`writeBlockSequenceToLocal(String fname, Pair<MatrixIndexes,MatrixValue>[] inValues, int len)`